#!/usr/bin/perl -w
#
# getAPIC.pl - get the APIC frame from a mp3 file's ID3v2 tag
#
# Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
#

use CGI;
use MP3::Tag;
$query=new CGI;

$NOAPIC_MIME="image/jpeg";
$NOAPIC="./noapic.jpg";

$file=$query->param('file');

$mp3=MP3::Tag->new($file);
if(defined $mp3)
{
  $mp3->getTags;

  if(exists $mp3->{ID3v2})
  {
    ($info, $_)=$mp3->{ID3v2}->getFrame("APIC");

    if(defined $info)
    {
      $mime=$info->{"MIME type"};
      $data=$info->{"_Data"};
    }
  }
}

if(defined $mime)
{
  #make sure mime type is image/jpeg not image/jpg !!!!
  $mime=~ s/jpg/jpeg/g;

  print $query->header(-type=>$mime);
  print $data;
}
else
{
  #send the default image
  print $query->header(-type=>$NOAPIC_MIME);
  open(IMG, "$NOAPIC") || die ("$!");
  while(<IMG>)
  {
    print;
  }
  close (IMG);
}

1;
